/*
    Copyright (c) 2011, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __DSA_HTML_REPORT_WEB_HANDLER_H__
#define __DSA_HTML_REPORT_WEB_HANDLER_H__

#include <string>
#include <boost/shared_ptr.hpp>

#include "html_web_handler.h"

namespace dSA
{

class HTMLReportWebHandler : public HTMLWebHandler
{
public:
    HTMLReportWebHandler(struct mg_connection* connection,
                   const struct mg_request_info* request_info);
    virtual void process();
protected:
    std::string upstreamPercent(int up);
    std::string downstreamPercent(int down);

    std::string taskOverview(boost::shared_ptr<dSLongTask> task);
    std::string transmissionQualitySummary(long long int id);
    std::string renderTQDevREcord(
        boost::shared_ptr<
            const Database::transmission_quality_device_record> rec);

    void transmissionQualityReport(boost::shared_ptr<dSLongTask> task,
                                   bool download = false);
    void taskReport();
};

}; // namespace

#endif//__DSA_HTML_REPORT_WEB_HANDLER_H__

