/*
    Copyright (c) 2010, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/

#ifndef __DSA_JSON_DSM_WEB_HANDLER_H__
#define __DSA_JSON_DSM_WEB_HANDLER_H__

#include <boost/shared_ptr.hpp>

#include "json_web_handler.h"

namespace dSA
{

class JSONdSMWebHandler : public JSONWebHandler
{
public:
    JSONdSMWebHandler(struct mg_connection* connection,
                   const struct mg_request_info* request_info);
    virtual void process();
private:
    boost::shared_ptr<const dSM> getDSMfromParam();

    std::string restartRegistration();
    std::string getCurrentTemperature();
    std::string blink();
};

}; // namespace

#endif//__DSA_JSON_DSM_WEB_HANDLER_H__

